#pragma once

#include <X-GSD/ComponentCollider.hpp>

#include <SFML/Graphics/Rect.hpp>

#include <set>

namespace xgsd {
    
    /* PhysicsEngine class. Very basic physics engine. At its current state, it only can check collisions of bounding-box colliders.
     
     Attention: This class is in very basic state and functionality, totally subject to change.
     */
    class PhysicsEngine
    {
        // Typedefs and enumerations
    public:
        typedef std::unique_ptr<PhysicsEngine>    Ptr;
        
        // Methods
    public:
        void    checkCollisions();
        
        void    addStaticCollider(ComponentCollider* collider);
        void    addDynamicCollider(ComponentCollider* collider);
        void    deleteStaticCollider(ComponentCollider* collider);
        void    deleteDynamicCollider(ComponentCollider* collider);
        
        // Variables (member / properties)
    private:
        std::set<ComponentCollider*>    staticColliders; // Colliders whose Entity does not have a RigidBody
        std::set<ComponentCollider*>    dynamicColliders; // Colliders whose Entity has a RigidBody
    };
    
} // namespace xgsd
